Index: contrib/nightly_tests/allext.conf
===================================================================
--- contrib/nightly_tests/allext.conf	(revision 586)
+++ contrib/nightly_tests/allext.conf	(revision 1132)
@@ -3,6 +3,5 @@
 # For this to pass, you need to setup the pg database for app_acct test.
 
-set(WITH_COVERAGE TRUE)
-set(CTEST_BUILD_NAME "All extensions")
+set(CTEST_BUILD_NAME "All extensions (default)")
 
 set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DALL_EXTENSIONS:BOOL=ON")
Index: contrib/nightly_tests/allextdbg.conf
===================================================================
--- contrib/nightly_tests/allextdbg.conf	(revision 862)
+++ contrib/nightly_tests/allextdbg.conf	(revision 1132)
@@ -4,5 +4,5 @@
 
 set(WITH_COVERAGE TRUE)
-set(CTEST_BUILD_NAME "All extensions")
+set(CTEST_BUILD_NAME "All extensions (Debug)")
 
 set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DALL_EXTENSIONS:BOOL=ON")
Index: contrib/nightly_tests/allextdeb.conf
===================================================================
--- contrib/nightly_tests/allextdeb.conf	(revision 1132)
+++ contrib/nightly_tests/allextdeb.conf	(revision 1132)
@@ -0,0 +1,10 @@
+
+# This configuration compiles all the extensions. It also performs a coverage test.
+# For this to pass, you need to setup the pg database for app_acct test.
+
+set(CTEST_BUILD_NAME "All extensions (DebianPackage)")
+
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DALL_EXTENSIONS:BOOL=ON")
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DCMAKE_BUILD_TYPE:STRING=DebianPackage")
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DTEST_APP_ACCT:BOOL=ON -DTEST_APP_ACCT_CONNINFO:STRING=user=test\\ dbname=test")
+
Index: contrib/nightly_tests/allextmax.conf
===================================================================
--- contrib/nightly_tests/allextmax.conf	(revision 1132)
+++ contrib/nightly_tests/allextmax.conf	(revision 1132)
@@ -0,0 +1,10 @@
+
+# This configuration compiles all the extensions. It also performs a coverage test.
+# For this to pass, you need to setup the pg database for app_acct test.
+
+set(CTEST_BUILD_NAME "All extensions (MaxPerformance)")
+
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DALL_EXTENSIONS:BOOL=ON")
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DCMAKE_BUILD_TYPE:STRING=MaxPerformance")
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DTEST_APP_ACCT:BOOL=ON -DTEST_APP_ACCT_CONNINFO:STRING=user=test\\ dbname=test")
+
Index: contrib/nightly_tests/allextprof.conf
===================================================================
--- contrib/nightly_tests/allextprof.conf	(revision 1132)
+++ contrib/nightly_tests/allextprof.conf	(revision 1132)
@@ -0,0 +1,11 @@
+
+# This configuration compiles all the extensions. It also performs a coverage test.
+# For this to pass, you need to setup the pg database for app_acct test.
+
+set(WITH_COVERAGE TRUE)
+set(CTEST_BUILD_NAME "All extensions (Profiling)")
+
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DALL_EXTENSIONS:BOOL=ON")
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DCMAKE_BUILD_TYPE:STRING=Profiling")
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DTEST_APP_ACCT:BOOL=ON -DTEST_APP_ACCT_CONNINFO:STRING=user=test\\ dbname=test")
+
Index: contrib/nightly_tests/allextrel.conf
===================================================================
--- contrib/nightly_tests/allextrel.conf	(revision 1132)
+++ contrib/nightly_tests/allextrel.conf	(revision 1132)
@@ -0,0 +1,10 @@
+
+# This configuration compiles all the extensions. It also performs a coverage test.
+# For this to pass, you need to setup the pg database for app_acct test.
+
+set(CTEST_BUILD_NAME "All extensions (Release)")
+
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DALL_EXTENSIONS:BOOL=ON")
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DCMAKE_BUILD_TYPE:STRING=Release")
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DTEST_APP_ACCT:BOOL=ON -DTEST_APP_ACCT_CONNINFO:STRING=user=test\\ dbname=test")
+
Index: contrib/nightly_tests/allextval.conf
===================================================================
--- contrib/nightly_tests/allextval.conf	(revision 1132)
+++ contrib/nightly_tests/allextval.conf	(revision 1132)
@@ -0,0 +1,11 @@
+
+# This configuration compiles all the extensions. It also performs a coverage test.
+# For this to pass, you need to setup the pg database for app_acct test.
+
+set(WITH_COVERAGE TRUE)
+set(CTEST_BUILD_NAME "All extensions (DebugValgrind)")
+
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DALL_EXTENSIONS:BOOL=ON")
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DCMAKE_BUILD_TYPE:STRING=DebugValgrind")
+set(CTEST_BUILD_OPTIONS "${CTEST_BUILD_OPTIONS} -DTEST_APP_ACCT:BOOL=ON -DTEST_APP_ACCT_CONNINFO:STRING=user=test\\ dbname=test")
+
Index: contrib/nightly_tests/tests.list
===================================================================
--- contrib/nightly_tests/tests.list	(revision 862)
+++ contrib/nightly_tests/tests.list	(revision 1132)
@@ -1,4 +1,9 @@
 allext
 allextdbg
+allextval
+allextret
+allextprof
+allextmax
+allextdeb
 alldefault
 nosctp