Index: extensions/dict_dcca_3gpp/dict_dcca_3gpp.c
===================================================================
--- extensions/dict_dcca_3gpp/dict_dcca_3gpp.c	(revision 1473)
+++ extensions/dict_dcca_3gpp/dict_dcca_3gpp.c	(revision 1476)
@@ -1224,5 +1224,5 @@
 	};
 
-	/* 3GPP TS 29.128 table 6.4.1-1 row Non-IP-Data                     */
+	/* Note: 3GPP TS 29.128 table 6.4.1-1 row Non-IP-Data               */
 	/* has type "Octetstring" instead of "OctetString".                 */
 	/* Non-IP-Data, OctetString, code 4315, section 6.4.19              */
@@ -1409,7 +1409,12 @@
 
 	/*==================================================================*/
-	/* 3GPP 29.140-700 (7.0.0 2007.07.05)                               */
+	/* 3GPP TS 29.140 V7.0.0 (2007-06)                                  */
+	/* From 3GPP 29140-700.doc                                          */
 	/*==================================================================*/
 
+	/*==================================================================*/
+	/* 3GPP TS 29.140 Table 6.3.1: Diameter MM10 Application AVPs       */
+	/*==================================================================*/
+
 	/* Served-User-Identity, Grouped, code 1100, section 6.3.1          */
 	{
@@ -1425,5 +1430,6 @@
 	};
 
-	/* reuses: MSISDN                                                   */
+	/* Note: Uses 3GPP TS 29.329 MSISDN.                                */
+
 	/* VASP-ID, UTF8String, code 1101, section 6.3.3                    */
 	{
@@ -1468,5 +1474,6 @@
 	};
 
-	/* reuses: 3GPP-IMSI                                                */
+	/* Note: Uses 3GPP TS 29.061 3GPP-IMSI.                             */
+
 	/* Sender-Address, UTF8String, code 1104, section 6.3.7             */
 	{
@@ -1508,5 +1515,5 @@
 	};
 
-	/* conflicts with one in (more common) 32.329                       */
+	/* Note: Name conflict with 3GPP TS 32.329 Sequence-Number (716).   */
 	/* Sequence-Number-29.140, Unsigned32, code 1107, section 6.3.10    */
 	{
@@ -1522,5 +1529,5 @@
 	};
 
-	/* conflicts with one in (more common) 32.299                       */
+	/* Note: Name conflict with 3GPP TS 32.299 Recipient-Address (1201). */
 	/* Recipient-Address-29.140, UTF8String, code 1108, section 6.3.11  */
 	{
@@ -1639,5 +1646,5 @@
 	};
 
-	/* conflicts with one in (more common) 32.299                       */
+	/* Note: Name conflict with 3GPP TS 32.299 Status (2702).           */
 	/* Status-29.140, Grouped, code 1116, section 6.3.19                */
 	{
@@ -1867,4 +1874,9 @@
 	/*==================================================================*/
 
+	/*==================================================================*/
+	/* 3GPP TS 29.210 Table 5.2: Gx specific Diameter AVPs              */
+	/* AVPs not provided by 3GPP TS 29.212.                             */
+	/*==================================================================*/
+
 	/* PDP-Session-Operation, Enumerated, code 1015, section 5.2.21     */
 	{
@@ -1892,5 +1904,5 @@
 	/*==================================================================*/
 
-	/* 3GPP TS 29.212 V12.1.0 (2013-06) removed ADC-Revalidation-Time.  */
+	/* Note: 3GPP TS 29.212 V12.1.0 (2013-06) removed ADC-Revalidation-Time. */
 	/* ADC-Revalidation-Time, Time, code 2801, section 5.3.93           */
 	{
@@ -2511,5 +2523,5 @@
 	};
 
-	/* 3GPP TS 29.212 V11.8.0 (2013-03) removed HeNB-BBF-FQDN.          */
+	/* Note: 3GPP TS 29.212 V11.8.0 (2013-03) removed HeNB-BBF-FQDN.    */
 	/* HeNB-BBF-FQDN, UTF8String, code 2803, section 5.3.94             */
 	{
@@ -2847,4 +2859,6 @@
 	};
 
+	/* Note: 3GPP TS 29.212 table 5.3.0.1 row PDN-Connection-ID         */
+	/* missing M.                                                       */
 	/* PDN-Connection-ID, OctetString, code 1065, section 5.3.58        */
 	{
@@ -3009,4 +3023,6 @@
 	};
 
+	/* Note: 3GPP TS 29.212 table 5.3.0.1 row PS-to-CS-Session-Continuity */
+	/* missing M.                                                       */
 	/* PS-to-CS-Session-Continuity, Enumerated, code 1099, section 5.3.84 */
 	{
@@ -4364,5 +4380,5 @@
 	};
 
-	/* 3GPP TS 29.214 table 5.3.0.1 row IMS-Content-Identifier          */
+	/* Note: 3GPP TS 29.214 table 5.3.0.1 row IMS-Content-Identifier    */
 	/* missing M, assume MUST NOT.                                      */
 	/* IMS-Content-Identifier, OctetString, code 563, section 5.3.60    */
@@ -4379,5 +4395,5 @@
 	};
 
-	/* 3GPP TS 29.214 table 5.3.0.1 row IMS-Content                     */
+	/* Note: 3GPP TS 29.214 table 5.3.0.1 row IMS-Content               */
 	/* missing M, assume MUST NOT.                                      */
 	/* IMS-Content-Type, Enumerated, code 564, section 5.3.61           */
@@ -5576,5 +5592,5 @@
 
 	/*==================================================================*/
-	/* 3GPP TS 29.272 Table 7.3.1/1: S6a/S6d                            */
+	/* 3GPP TS 29.272 Table 7.3.1/1: S6a/S6d, S7a/S7d and S13/S13' specific DiameterAVPs */
 	/*==================================================================*/
 
@@ -6564,5 +6580,5 @@
 	};
 
-	/* 3GPP TS 29.272 V12.5.0 (2014-06) corrected table 7.3.1/1         */
+	/* Note: 3GPP TS 29.272 V12.5.0 (2014-06) corrected table 7.3.1/1   */
 	/* row SS-Status to be OctetString instead of Grouped.              */
 	/* Clause 7.3.88 already described SS-Status as OctetString.        */
@@ -6719,5 +6735,5 @@
 	};
 
-	/* 3GPP TS 29.272 V12.4.0 (2014-03) renamed                         */
+	/* Note: 3GPP TS 29.272 V12.4.0 (2014-03) renamed                   */
 	/* Call-Barring-Infor-List to Call-Barring-Info.                    */
 	/* Call-Barring-Info, Grouped, code 1488, section 7.3.101           */
@@ -6889,5 +6905,5 @@
 	};
 
-	/* 3GPP TS 29.272 table 7.3.1/1 incorrectly has a space             */
+	/* Note: 3GPP TS 29.272 table 7.3.1/1 incorrectly has a space       */
 	/* instead of hyphen in the row for MME-Location-Information.       */
 	/* Generated name renamed from MME-LocationInformation.             */
@@ -7577,5 +7593,5 @@
 	};
 
-	/* 3GPP TS 29.272 V12.9.0 (2015-12) changed AVP code of             */
+	/* Note: 3GPP TS 29.272 V12.9.0 (2015-12) changed AVP code of       */
 	/* Measurement-Period-LTE from 1656 to 1655.                        */
 	/* Measurement-Period-LTE, Enumerated, code 1655, section 7.3.166   */
@@ -7595,5 +7611,5 @@
 	};
 
-	/* 3GPP TS 29.272 V12.9.0 (2015-12) changed AVP code of             */
+	/* Note: 3GPP TS 29.272 V12.9.0 (2015-12) changed AVP code of       */
 	/* Measurement-Period-UMTS from 1655 to 1656.                       */
 	/* Measurement-Period-UMTS, Enumerated, code 1656, section 7.3.167  */
@@ -7999,5 +8015,5 @@
 	};
 
-	/* 3GPP TS 29.272 table 7.3.1/1 row Preferred-Data-Mode             */
+	/* Note: 3GPP TS 29.272 table 7.3.1/1 row Preferred-Data-Mode       */
 	/* incorrectly has value type Grouped instead of Unsigned32,        */
 	/* conflicting with clause 7.3.209.                                 */
@@ -8311,5 +8327,5 @@
 	};
 
-	/* Name conflict with 29.229 User-Data (606), renamed               */
+	/* Note: Name conflict with 3GPP TS 29.229 User-Data (606).         */
 	/* User-Data-29.329, OctetString, code 702, section 6.3.3           */
 	{
@@ -10066,5 +10082,5 @@
 	};
 
-	/* 3GPP TS 32.299 V11.8.0 (2013-07) corrected table 7.2             */
+	/* Note: 3GPP TS 32.299 V11.8.0 (2013-07) corrected table 7.2       */
 	/* to have a hyphen instead of space in the name.                   */
 	/* Generated name renamed from MBMSGW-Address.                      */
Index: extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv
===================================================================
--- extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv	(revision 1473)
+++ extensions/dict_dcca_3gpp/dict_dcca_3gpp.csv	(revision 1476)
@@ -104,5 +104,5 @@
 UE-Count,4308,6.4.13,Unsigned32,"M,V",,,,No
 Connection-Action,4314,6.4.18,Unsigned32,"M,V",,,,No
-# 3GPP TS 29.128 table 6.4.1-1 row Non-IP-Data,,,,,,,,
+# Note: 3GPP TS 29.128 table 6.4.1-1 row Non-IP-Data,,,,,,,,
 "# has type ""Octetstring"" instead of ""OctetString"".",,,,,,,,
 Non-IP-Data,4315,6.4.19,OctetString,"M,V",,,,No
@@ -123,19 +123,26 @@
 @standard,3GPP TS 29.140,,,,,,,
 #=,,,,,,,,
-# 3GPP 29.140-700 (7.0.0 2007.07.05),,,,,,,,
+# 3GPP TS 29.140 V7.0.0 (2007-06),,,,,,,,
+# From 3GPP 29140-700.doc,,,,,,,,
+#=,,,,,,,,
+#,,,,,,,,
+#=,,,,,,,,
+# 3GPP TS 29.140 Table 6.3.1: Diameter MM10 Application AVPs,,,,,,,,
 #=,,,,,,,,
 #,,,,,,,,
 Served-User-Identity,1100,6.3.1,Grouped,"M,V",,,,N
-# reuses: MSISDN,701,6.3.2,OctetString,"M,V",,,,N
+# Note: Uses 3GPP TS 29.329 MSISDN.,701,6.3.2,OctetString,"M,V",,,,N
+#,,,,,,,,
 VASP-ID,1101,6.3.3,UTF8String,"M,V",,,,N
 VAS-ID,1102,6.3.4,UTF8String,"M,V",,,,N
 Trigger-Event,1103,6.3.5,Enumerated,"M,V",,,,N
-# reuses: 3GPP-IMSI,1,6.3.6,UTF8String,"M,V",,,,N
+# Note: Uses 3GPP TS 29.061 3GPP-IMSI.,1,6.3.6,UTF8String,"M,V",,,,N
+#,,,,,,,,
 Sender-Address,1104,6.3.7,UTF8String,"M,V",,,,N
 Initial-Recipient-Address,1105,6.3.8,Grouped,"M,V",,,,N
 Result-Recipient-Address,1106,6.3.9,Grouped,"M,V",,,,N
-# conflicts with one in (more common) 32.329,,,,,,,,
+# Note: Name conflict with 3GPP TS 32.329 Sequence-Number (716).,,,,,,,,
 Sequence-Number-29.140,1107,6.3.10,Unsigned32,"M,V",,,,N
-# conflicts with one in (more common) 32.299,,,,,,,,
+# Note: Name conflict with 3GPP TS 32.299 Recipient-Address (1201).,,,,,,,,
 Recipient-Address-29.140,1108,6.3.11,UTF8String,"M,V",,,,N
 Routeing-Address,1109,6.3.12,UTF8String,"M,V",,,,N
@@ -146,5 +153,5 @@
 Service-Key,1114,6.3.17,UTF8String,"M,V",,,,N
 Billing-Information,1115,6.3.18,UTF8String,"M,V",,,,N
-# conflicts with one in (more common) 32.299,,,,,,,,
+# Note: Name conflict with 3GPP TS 32.299 Status (2702).,,,,,,,,
 Status-29.140,1116,6.3.19,Grouped,"M,V",,,,N
 Status-Code,1117,6.3.20,UTF8String,"M,V",,,,N
@@ -183,4 +190,9 @@
 #=,,,,,,,,
 #,,,,,,,,
+#=,,,,,,,,
+# 3GPP TS 29.210 Table 5.2: Gx specific Diameter AVPs,,,,,,,,
+# AVPs not provided by 3GPP TS 29.212.,,,,,,,,
+#=,,,,,,,,
+#,,,,,,,,
 PDP-Session-Operation,1015,5.2.21,Enumerated,"M,V",P,,,Y
 ,,,,,,,,
@@ -195,5 +207,5 @@
 #=,,,,,,,,
 #,,,,,,,,
-# 3GPP TS 29.212 V12.1.0 (2013-06) removed ADC-Revalidation-Time.,,,,,,,,
+# Note: 3GPP TS 29.212 V12.1.0 (2013-06) removed ADC-Revalidation-Time.,,,,,,,,
 ADC-Revalidation-Time,2801,5.3.93,Time,V,P,,M,Y
 3GPP-PS-Data-Off-Status,2847,5.3.133,Enumerated,V,P,,M,Y
@@ -241,5 +253,5 @@
 Guaranteed-Bitrate-DL,1025,5.3.25,Unsigned32,"M,V",P,,,Y
 Guaranteed-Bitrate-UL,1026,5.3.26,Unsigned32,"M,V",P,,,Y
-# 3GPP TS 29.212 V11.8.0 (2013-03) removed HeNB-BBF-FQDN.,,,,,,,,
+# Note: 3GPP TS 29.212 V11.8.0 (2013-03) removed HeNB-BBF-FQDN.,,,,,,,,
 HeNB-BBF-FQDN,2803,5.3.94,UTF8String,V,P,,M,Y
 HeNB-Local-IP-Address,2804,5.3.95,Address,V,P,,M,Y
@@ -265,4 +277,6 @@
 Packet-Filter-Usage,1072,5.3.66,Enumerated,V,P,,M,Y
 PCC-Rule-Status,1019,5.3.19,Enumerated,"M,V",P,,,Y
+# Note: 3GPP TS 29.212 table 5.3.0.1 row PDN-Connection-ID,,,,,,,,
+"# missing M.",,,,,,,,
 PDN-Connection-ID,1065,5.3.58,OctetString,V,P,,,Y
 PRA-Install,2845,5.3.130,Grouped,V,P,,M,
@@ -277,4 +291,6 @@
 Presence-Reporting-Area-Status,2823,5.3.110,Unsigned32,V,P,,M,Y
 Priority-Level,1046,5.3.45,Unsigned32,V,P,,M,Y
+# Note: 3GPP TS 29.212 table 5.3.0.1 row PS-to-CS-Session-Continuity,,,,,,,,
+"# missing M.",,,,,,,,
 PS-to-CS-Session-Continuity,1099,5.3.84,Enumerated,V,P,,,Y
 QoS-Class-Identifier,1028,5.3.17,Enumerated,"M,V",P,,,Y
@@ -401,8 +417,8 @@
 Flow-Usage,512,5.3.12,Enumerated,"M,V",P,,,Y
 GCS-Identifier,538,5.3.36,OctetString,V,P,,M,Y
-# 3GPP TS 29.214 table 5.3.0.1 row IMS-Content-Identifier,,,,,,,,
+# Note: 3GPP TS 29.214 table 5.3.0.1 row IMS-Content-Identifier,,,,,,,,
 "# missing M, assume MUST NOT.",,,,,,,,
 IMS-Content-Identifier,563,5.3.60,OctetString,V,P,,M,Y
-# 3GPP TS 29.214 table 5.3.0.1 row IMS-Content,,,,,,,,
+# Note: 3GPP TS 29.214 table 5.3.0.1 row IMS-Content,,,,,,,,
 "# missing M, assume MUST NOT.",,,,,,,,
 IMS-Content-Type,564,5.3.61,Enumerated,V,P,,M,Y
@@ -507,5 +523,5 @@
 #,,,,,,,,
 #=,,,,,,,,
-# 3GPP TS 29.272 Table 7.3.1/1: S6a/S6d, S7a/S7d and S13/S13' specific DiameterAVPs,,,,,,,,
+"# 3GPP TS 29.272 Table 7.3.1/1: S6a/S6d, S7a/S7d and S13/S13' specific DiameterAVPs",,,,,,,,
 #=,,,,,,,,
 #,,,,,,,,
@@ -583,5 +599,5 @@
 LCS-PrivacyException,1475,7.3.86,Grouped,"M,V",,,,N
 SS-Code,1476,7.3.87,OctetString,"M,V",,,,N
-# 3GPP TS 29.272 V12.5.0 (2014-06) corrected table 7.3.1/1,,,,,,,,
+# Note: 3GPP TS 29.272 V12.5.0 (2014-06) corrected table 7.3.1/1,,,,,,,,
 # row SS-Status to be OctetString instead of Grouped.,,,,,,,,
 # Clause 7.3.88 already described SS-Status as OctetString.,,,,,,,,
@@ -597,5 +613,5 @@
 Teleservice-List,1486,7.3.99,Grouped,"M,V",,,,N
 TS-Code,1487,7.3.100,OctetString,"M,V",,,,N
-# 3GPP TS 29.272 V12.4.0 (2014-03) renamed,,,,,,,,
+# Note: 3GPP TS 29.272 V12.4.0 (2014-03) renamed,,,,,,,,
 # Call-Barring-Infor-List to Call-Barring-Info.,,,,,,,,
 Call-Barring-Info,1488,7.3.101,Grouped,"M,V",,,,N
@@ -611,5 +627,5 @@
 SGSN-User-State,1498,7.3.113,Grouped,V,,,M,N
 User-State,1499,7.3.114,Enumerated,V,,,M,N
-# 3GPP TS 29.272 table 7.3.1/1 incorrectly has a space,,,,,,,,
+# Note: 3GPP TS 29.272 table 7.3.1/1 incorrectly has a space,,,,,,,,
 # instead of hyphen in the row for MME-Location-Information.,,,,,,,,
 # Generated name renamed from MME-LocationInformation.,,,,,,,,
@@ -663,8 +679,8 @@
 Daylight-Saving-Time,1650,7.3.164,Enumerated,V,,,M,N
 Subscription-Data-Flags,1654,7.3.165,Unsigned32,V,,,M,N
-# 3GPP TS 29.272 V12.9.0 (2015-12) changed AVP code of,,,,,,,,
+# Note: 3GPP TS 29.272 V12.9.0 (2015-12) changed AVP code of,,,,,,,,
 # Measurement-Period-LTE from 1656 to 1655.,,,,,,,,
 Measurement-Period-LTE,1655,7.3.166,Enumerated,V,,,M,N
-# 3GPP TS 29.272 V12.9.0 (2015-12) changed AVP code of,,,,,,,,
+# Note: 3GPP TS 29.272 V12.9.0 (2015-12) changed AVP code of,,,,,,,,
 # Measurement-Period-UMTS from 1655 to 1656.,,,,,,,,
 Measurement-Period-UMTS,1656,7.3.167,Enumerated,V,,,M,N
@@ -698,5 +714,5 @@
 SCEF-Realm,1684,7.3.207,DiameterIdentity,V,,,M,N
 Subscription-Data-Deletion,1685,7.3.208,Grouped,V,,,M,N
-# 3GPP TS 29.272 table 7.3.1/1 row Preferred-Data-Mode,,,,,,,,
+# Note: 3GPP TS 29.272 table 7.3.1/1 row Preferred-Data-Mode,,,,,,,,
 "# incorrectly has value type Grouped instead of Unsigned32,",,,,,,,,
 # conflicting with clause 7.3.209.,,,,,,,,
@@ -730,5 +746,5 @@
 User-Identity,700,6.3.1,Grouped,"M,V",,,,N
 MSISDN,701,6.3.2,OctetString,"M,V",,,,N
-"# Name conflict with 29.229 User-Data (606), renamed",,,,,,,,
+# Note: Name conflict with 3GPP TS 29.229 User-Data (606).,,,,,,,,
 User-Data-29.329,702,6.3.3,OctetString,"M,V",,,,N
 Data-Reference,703,6.3.4,Enumerated,"M,V",,,,N
@@ -873,5 +889,5 @@
 Low-Balance-Indication,2020,,Enumerated,"M,V",P,,,N
 Low-Priority-Indicator,2602,,Enumerated,"M,V",P,,,N
-# 3GPP TS 32.299 V11.8.0 (2013-07) corrected table 7.2,,,,,,,,
+# Note: 3GPP TS 32.299 V11.8.0 (2013-07) corrected table 7.2,,,,,,,,
 # to have a hyphen instead of space in the name.,,,,,,,,
 # Generated name renamed from MBMSGW-Address.,,,,,,,,